# ODIFLAT -- Process flat exposures.

procedure odiflat (input)

string	input			{prompt="List of input ODI files"}
file	output = "flat_+"	{prompt="List of processed flat files\n"}

bool	trim = yes		{prompt="Trim?"}
bool	fixpix = yes		{prompt="Fix bad pixels by interpolation?"}
bool	overscan = yes		{prompt="Overscan correction?"}
bool	biascor = yes		{prompt="Apply bias/dark count calibration?"}
bool	normalize = yes		{prompt="Normalize?\n"}

string	bpm = ""		{prompt="List of masks or expression"}
string	biases = "(BIASFIL//'['//EXTNAME//']')"	{prompt="List of bias/dark images"} 
real	floor = INDEF		{prompt="Output minimum value (ADU)\n"}

bool	list = no		{prompt="List only?"}
string	logfiles = "STDOUT,logfile"	{prompt="Log files"}

begin
	bool	replace
	string	outtype, linval
	struct	expr, repexpr

	# Set output type.
	if (list)
	    outtype = "vlist"
	else
	    outtype = "image"

	# Set replacement.
	if (isindef(floor))
	   replace = no
	else
	   replace = yes
	repexpr = "(max($I," // floor // "))"

	# Process or list.
	_odiproc (input, output, intype="(flat)", outtype=outtype,
	    logfiles=logfiles, trim=trim, fixpix=fixpix, biascor=overscan,
	    darkcor=biascor, replace=replace,
	    normalize=normalize, bpm=bpm, darks=biases,
	    repexpr=repexpr, taskname="odiflat")

end
