# ODIMERGE -- Merge ODI cells.
#
# This is a preliminary version.

procedure odimerge (input, output)

string	input			{prompt="List of input ODI files"}
file	output			{prompt="Output rootname"}
string	logfile = "STDOUT"	{prompt="Log output"}

struct	*fd

begin
	int	nx, ny, xgap, ygap, ox, oy, c1, c2, l1, l2
	string	in, out
	file	tmplist

	in = input
	out = output

	combine (in, out, logfile="STDOUT",
	    headers="", bpmasks="", rejmasks="", nrejmasks="",
	    expmasks="", sigmas="", imcmb="",
	    select="", group="substr(ccdname,4,5)",
	    seqval="", seqgap=INDEF, extension="", delete=no,
	    combine="average", reject="none", outtype="real", outlimits="",
	    offsets="physical", masktype="none", maskvalue="0", blank=0.,
	    scale="none", zero="none", weight="none", statsec="",
	    lthreshold=INDEF, hthreshold=INDEF, nlow=1, nhigh=1, nkeep=1,
	    mclip=yes, lsigma=3., hsigma=3., rdnoise="0.", gain="1.",
	    snoise="0.", sigscale=0.1, pclip=-0.5, grow=0.)

	tmplist = mktemp ("tmp$iraf") // ".list"
	sections (out//"??.fits", option="fullname", > tmplist)
	fd = tmplist
	while (fscan (fd, out) != EOF) {
	    hedit (out, "CCDSEC,NCOMBINE,CELLGAP*,AMPNAME*,PROC0*,GAIN,RDNOISE",
		del+, verify-, show-, update+)
	    hselect (out, "NAXIS1,NAXIS2,OTAGAP1,OTAGAP2", yes) |
	        scan (nx, ny, xgap, ygap)
	    hselect (out, "CCDNAME", yes) | scanf ("ota%1d%1d", ox, oy)
	    c1 = ox * (nx + xgap) + 1
	    c2 = c1 + nx
	    l1 = oy * (ny + ygap) + 1
	    l2 = l1 + ny
	    printf ("[%d:%d,%d:%d]\n", c1, c2, l1, l2) | scan (in)
	    hedit (out, "DETSEC", in, add-, del-, verify-, show-, update+)
	}
	fd = ""; delete (tmplist, verify-)

end
